package cvj2.app.command;

import cvj2.app.Config;

/**
 * アプリケーションが実装しているコマンドの一覧
 */
public enum Command {
  FILE_EXIT("ファイル", "終了", 'x'),
  FILE_OPEN_DIR("ファイル", "ディレクトリを開く", 'o'),
  FILE_NEW_DIR("ファイル", "ディレクトリ作成", 'n'),
  FILE_NEW_FILE("ファイル", "ファイル作成", 'f'),
  FILE_PROPERTY("ファイル", "プロパティ", 'p'),
  FILE_EXEC("ファイル", Config.OS_NAME + "の機能で開く", 'e'),
  FILE_LAUNCH("ファイル", "プログラム起動", '\0'),
  FILE_LAUNCH_0("ファイル", "プログラム起動1", '\0'),
  FILE_LAUNCH_1("ファイル", "プログラム起動2", '\0'),
  FILE_LAUNCH_2("ファイル", "プログラム起動3", '\0'),
  FILE_LAUNCH_3("ファイル", "プログラム起動4", '\0'),
  FILE_LAUNCH_4("ファイル", "プログラム起動5", '\0'),
  FILE_LAUNCH_5("ファイル", "プログラム起動6", '\0'),
  FILE_LAUNCH_6("ファイル", "プログラム起動7", '\0'),
  FILE_LAUNCH_7("ファイル", "プログラム起動8", '\0'),
  FILE_LAUNCH_8("ファイル", "プログラム起動9", '\0'),
  FILE_LAUNCH_9("ファイル", "プログラム起動10", '\0'),

  EDIT_CUT("編集", "切り取り", 't'),
  EDIT_COPY("編集", "コピー", 'c'),
  EDIT_PASTE("編集", "貼り付け", 'p'),
  EDIT_DELETE("編集", "削除", 'd'),
  EDIT_RENAME("編集", "名前変更", 'r'),
  EDIT_CONFIG("編集", "設定", 'c'),
  EDIT_BOOKMARK("編集", "ブックマーク", 'b'),
  EDIT_THUMBNAIL("編集", "サムネイル", 't'),
  EDIT_ADD_THUMBNAIL("編集", "サムネイル一括登録", '\0'),
  EDIT_SEARCH_PREV("編集", "前を検索", '\0'),
  EDIT_SEARCH_NEXT("編集", "次を検索", '\0'),

  VIEW_CLOSE("表示", "閉じる", 'c'),
  VIEW_SWITCH_FULLSCREEN("表示", "フルスクリーン切り替え", 'f'),
  VIEW_SHOW_IMAGE_INFO("表示", "画像情報を表示する", 's'),
  VIEW_LIST_MODE("表示", "リスト表示", 'l'),
  VIEW_THUMBNAIL_MODE("表示", "サムネイル表示", 't'),
  VIEW_THUMBNAIL_SIZE_EXPAND("表示", "サムネイル拡大", '\0'),
  VIEW_THUMBNAIL_SIZE_SHRINK("表示", "サムネイル縮小", '\0'),

  VIEW_HOME_DIR("表示", "ホーム", 'h'),
  VIEW_REFRESH("表示", "再表示", 'r'),
  VIEW_HIDE_FILES("表示", "非表示ファイルを隠す", 'h'),
  VIEW_CLEAR_CACHE("表示", "メモリキャッシュをクリア", '\0'),
  VIEW_PREV_DIR("表示", "前のディレクトリ", 'p'),
  VIEW_NEXT_DIR("表示", "次のディレクトリ", 'n'),
  VIEW_PARENT_DIR("表示", "親ディレクトリ", 'a'),
  VIEW_ENTER_CHILD("表示", "子ディレクトリ", 'e'),
  VIEW_PARENT_DIR_ON_LIST_MODE("表示", "親ディレクトリ(リスト表示時)", '\0'),
  VIEW_ENTER_CHILD_ON_LIST_MODE("表示", "子ディレクトリ(リスト表示時)", '\0'),

  VIEW_IMAGE_PREV_COLUMN("表示", "次の画像", '\0'),
  VIEW_IMAGE_NEXT_COLUMN("表示", "前の画像", '\0'),
  VIEW_IMAGE_PREV_ROW("表示", "次の行の画像", '\0'),
  VIEW_IMAGE_NEXT_ROW("表示", "前の行の画像", '\0'),
  VIEW_IMAGE_PREV_PAGE("表示", "次の画面の画像", '\0'),
  VIEW_IMAGE_NEXT_PAGE("表示", "前の画面の画像", '\0'),
  VIEW_IMAGE_TOP("表示", "先頭の画像", '\0'),
  VIEW_IMAGE_TAIL("表示", "最後の画像", '\0'),

  VIEW_SORT("", "", '\0'),
  VIEW_SORT_NAME("ソート", "名前でソート", '\0'),
  VIEW_SORT_EXT("ソート", "拡張子でソート", '\0'),
  VIEW_SORT_SIZE("ソート", "サイズでソート", '\0'),
  VIEW_SORT_DATE("ソート", "更新日時でソート", '\0'),
  
  VIEW_ROTATE("画像", "反時計回りに回転", '\0'),
  VIEW_ROTATE_REVERSE("画像", "時計回りに", '\0'),
  VIEW_TOGGLE_2PAGE_MODE("画像", "2ぺーじ表示", '\0'),
  VIEW_TOGGLE_2PAGE_RL("画像", "2ページ表示の左右入れ替え", '\0'),

  VIEW_ZOOM_IN("ズーム", "拡大", '\0'),
  VIEW_ZOOM_OUT("ズーム", "縮小", '\0'),
  VIEW_ZOOM_ORIGINAL_SIZE("ズーム", "原寸表示", '\0'),
  VIEW_ZOOM_FIT_TO_WINDOW("ズーム", "ウインドウに合わせて表示", '\0'),
  VIEW_ZOOM_FIT_TO_WINDOW_OR_RETURN_MAIN("ズーム", "ウインドウに合わせて表示 or メイン画面に戻る", '\0'),

  VIEW_ZOOM_MOVE_UP("ズーム", "ズーム画像を上にスクロール", '\0'),
  VIEW_ZOOM_MOVE_DOWN("ズーム", "ズーム画像を下にスクロール", '\0'),
  VIEW_ZOOM_MOVE_RIGHT("ズーム", "ズーム画像を右にスクロール", '\0'),
  VIEW_ZOOM_MOVE_LEFT("ズーム", "ズーム画像を左にスクロール", '\0'),
  VIEW_ZOOM_MOVE_CENTER("ズーム", "ズーム画像の中心にスクロール", '\0'),
  
  TAB_OPEN("タブ", "新規タブ", 'o'),
  TAB_CLOSE("タブ", "タブを閉じる", 'c'),
  TAB_PREV("タブ", "次のタブ", 'n'),
  TAB_NEXT("タブ", "前のタブ", 'p'),

  HELP_SMSEARCH_TEST("ヘルプ", "検索テスト", 's'),
  HELP_SYSMON("ヘルプ", "システムモニタ", 'm'),
  HELP_ABOUT("ヘルプ", Config.APP_NAME + "について", 'a');

  /** 外部起動プログラムに割り当てたCommandの数 */
  public static final int MAX_LAUNCH = 10;

  private String group;
  private String name;
  private char mnemonic;
  
  private Command(String group, String name, char mnemonic) {
    this.group = group;
    this.name = name;
    this.mnemonic = mnemonic;
  }

  /** コマンドのグループ (入力カスタマイズの時に表示する) */
  public String getGroup() {
    return group;
  }
  /** コマンドの名前 */
  public String getName() {
    return name;
  }

  /**
   * メニューに表示する名称を取得
   */
  public String getMenuName() {
    if (mnemonic == '\0') return getName();
    int i = getName().toLowerCase().indexOf(("" + mnemonic).toLowerCase());
    if (i < 0) return getName() + "(&" + mnemonic + ")";
    return getName().substring(0, i) + "&" + getName().substring(i);
  }
}
