package cvj2.app.command;

import static cvj2.app.command.Command.*;

import org.eclipse.swt.SWT;

import cvj2.gui.swt.ui.input.KeyCombination;
import cvj2.gui.swt.ui.input.MouseCombination;

/**
 * デフォルトのコマンド入力設定作成クラス
 */
public class DefaultCommandMapInputCreator {
  private CommandMapInput map;
  
  /**
   * MainWindow のキー入力対応表を生成する
   */
  public CommandMapInput createMainWindowCommandMap() {
    map = new CommandMapInput();
    
    k(FILE_OPEN_DIR, SWT.CTRL | 'o');
    k(FILE_NEW_DIR, SWT.CTRL | 'k');
    k(FILE_NEW_FILE, SWT.CTRL | 'f');
    k(FILE_EXEC, SWT.CTRL | SWT.CR);
    k(FILE_LAUNCH_0, SWT.CTRL | '1');
    k(FILE_LAUNCH_1, SWT.CTRL | '2');
    k(FILE_LAUNCH_2, SWT.CTRL | '3');
    k(FILE_LAUNCH_3, SWT.CTRL | '4');
    k(FILE_LAUNCH_4, SWT.CTRL | '5');
    k(FILE_LAUNCH_5, SWT.CTRL | '6');
    k(FILE_LAUNCH_6, SWT.CTRL | '7');
    k(FILE_LAUNCH_7, SWT.CTRL | '8');
    k(FILE_LAUNCH_8, SWT.CTRL | '9');
    k(FILE_LAUNCH_9, SWT.CTRL | '0');
    k(FILE_PROPERTY, SWT.ALT | SWT.CR);
    k(FILE_EXIT, SWT.CTRL | 'q');

    k(EDIT_CUT, SWT.CTRL | 'x');
    k(EDIT_COPY, SWT.CTRL | 'c');
    k(EDIT_PASTE, SWT.CTRL | 'v');
    k(EDIT_DELETE, SWT.DEL);
    k(EDIT_DELETE, SWT.SHIFT | SWT.DEL);
    k(EDIT_RENAME, SWT.F2);
    k(EDIT_SEARCH_PREV, SWT.CTRL | 'p');
    k(EDIT_SEARCH_PREV, SWT.SHIFT | SWT.F3);
    k(EDIT_SEARCH_NEXT, SWT.CTRL | 'n');
    k(EDIT_SEARCH_NEXT, SWT.F3);
    k(EDIT_CONFIG, SWT.CTRL | 's');
    k(EDIT_THUMBNAIL, SWT.CTRL | 'm');
    k(EDIT_ADD_THUMBNAIL, SWT.CTRL | SWT.SHIFT | 'm');
    k(EDIT_BOOKMARK, SWT.CTRL | 'b');

    k(VIEW_LIST_MODE, SWT.CTRL | 'l');
    k(VIEW_THUMBNAIL_SIZE_SHRINK, SWT.CTRL | SWT.KEYPAD_SUBTRACT);
    k(VIEW_THUMBNAIL_SIZE_EXPAND, SWT.CTRL | SWT.KEYPAD_ADD);

    k(VIEW_HOME_DIR, SWT.ALT | SWT.HOME);
    k(VIEW_REFRESH, SWT.F5);
    k(VIEW_REFRESH, SWT.CTRL | 'r');
    k(VIEW_HIDE_FILES, SWT.CTRL | 'h');
    k(VIEW_CLEAR_CACHE, SWT.CTRL | SWT.F5);
    k(VIEW_CLEAR_CACHE, SWT.CTRL | SWT.SHIFT | 'r');
    k(VIEW_PREV_DIR, SWT.ALT | SWT.ARROW_UP);
    k(VIEW_PREV_DIR, SWT.ALT | SWT.ARROW_LEFT);
    k(VIEW_NEXT_DIR, SWT.ALT | SWT.ARROW_RIGHT);
    k(VIEW_NEXT_DIR, SWT.ALT | SWT.ARROW_DOWN);
    k(VIEW_PARENT_DIR, SWT.BS);
    m(VIEW_PARENT_DIR, SWT.BUTTON2, 1);
    k(VIEW_ENTER_CHILD, SWT.CR);
    k(VIEW_ENTER_CHILD, SWT.KEYPAD_CR);
    m(VIEW_ENTER_CHILD, SWT.BUTTON1, 2);
    k(VIEW_PARENT_DIR_ON_LIST_MODE, SWT.ARROW_LEFT);
    k(VIEW_ENTER_CHILD_ON_LIST_MODE, SWT.ARROW_RIGHT);

    k(VIEW_SORT_NAME, SWT.ALT | '1');
    k(VIEW_SORT_EXT, SWT.ALT | '2');
    k(VIEW_SORT_SIZE, SWT.ALT | '3');
    k(VIEW_SORT_DATE, SWT.ALT | '4');
    
    k(TAB_OPEN, SWT.CTRL | 't');
    k(TAB_CLOSE, SWT.CTRL | 'w');
    k(TAB_CLOSE, SWT.CTRL | SWT.F4);
    k(TAB_PREV, SWT.CTRL | SWT.PAGE_UP);
    k(TAB_NEXT, SWT.CTRL | SWT.PAGE_DOWN);
    k(TAB_PREV, SWT.CTRL | SWT.SHIFT | SWT.TAB);
    k(TAB_NEXT, SWT.CTRL | SWT.TAB);

    return map;
  }

  /**
   * ViewWindow のキー入力対応表を生成する
   */
  public CommandMapInput createViewWindowCommandMap() {
    map = new CommandMapInput();
    
    k(EDIT_COPY, SWT.CTRL | 'c');
    k(EDIT_DELETE, SWT.DEL);
    k(EDIT_DELETE, SWT.SHIFT | SWT.DEL);
    k(EDIT_RENAME, SWT.F2);

    k(VIEW_REFRESH, SWT.F5);
    k(VIEW_PREV_DIR, SWT.ALT | SWT.ARROW_UP);
    k(VIEW_PREV_DIR, SWT.ALT | SWT.ARROW_LEFT);
    k(VIEW_NEXT_DIR, SWT.ALT | SWT.ARROW_RIGHT);
    k(VIEW_NEXT_DIR, SWT.ALT | SWT.ARROW_DOWN);
    k(VIEW_PARENT_DIR, SWT.BS);

    k(TAB_PREV, SWT.CTRL | SWT.PAGE_UP);
    k(TAB_NEXT, SWT.CTRL | SWT.PAGE_DOWN);

    k(VIEW_CLOSE, SWT.CTRL | 'q');
    k(VIEW_CLOSE, SWT.ESC);
    k(VIEW_SWITCH_FULLSCREEN, SWT.ALT | SWT.CR);
    k(VIEW_SWITCH_FULLSCREEN, SWT.F11);
    k(VIEW_SHOW_IMAGE_INFO, SWT.CTRL | 'i');
    k(VIEW_SHOW_IMAGE_INFO, 'i');

    k(VIEW_ROTATE, SWT.ALT | SWT.PAGE_UP);
    k(VIEW_ROTATE_REVERSE, SWT.ALT | SWT.PAGE_DOWN);
    k(VIEW_TOGGLE_2PAGE_MODE, ' ');
    k(VIEW_TOGGLE_2PAGE_RL, '\\');

    k(VIEW_ZOOM_IN, SWT.KEYPAD_ADD);
    k(VIEW_ZOOM_OUT, SWT.KEYPAD_SUBTRACT);
    k(VIEW_ZOOM_ORIGINAL_SIZE, SWT.KEYPAD_0);
    k(VIEW_ZOOM_FIT_TO_WINDOW, '=');
    k(VIEW_ZOOM_FIT_TO_WINDOW_OR_RETURN_MAIN, SWT.CR);
    k(VIEW_ZOOM_FIT_TO_WINDOW_OR_RETURN_MAIN, SWT.KEYPAD_CR);
    m(VIEW_ZOOM_FIT_TO_WINDOW_OR_RETURN_MAIN, SWT.BUTTON2, 1);

    k(VIEW_ZOOM_MOVE_UP, SWT.KEYPAD_8);
    k(VIEW_ZOOM_MOVE_DOWN, SWT.KEYPAD_2);
    k(VIEW_ZOOM_MOVE_RIGHT, SWT.KEYPAD_6);
    k(VIEW_ZOOM_MOVE_LEFT, SWT.KEYPAD_4);
    k(VIEW_ZOOM_MOVE_CENTER, SWT.KEYPAD_5);
    k(VIEW_ZOOM_MOVE_UP, SWT.SHIFT | SWT.ARROW_UP);
    k(VIEW_ZOOM_MOVE_DOWN, SWT.SHIFT | SWT.ARROW_DOWN);
    k(VIEW_ZOOM_MOVE_RIGHT, SWT.SHIFT | SWT.ARROW_RIGHT);
    k(VIEW_ZOOM_MOVE_LEFT, SWT.SHIFT | SWT.ARROW_LEFT);
    k(VIEW_ZOOM_MOVE_UP, SWT.CTRL | SWT.ARROW_UP);
    k(VIEW_ZOOM_MOVE_DOWN, SWT.CTRL | SWT.ARROW_DOWN);
    k(VIEW_ZOOM_MOVE_RIGHT, SWT.CTRL | SWT.ARROW_RIGHT);
    k(VIEW_ZOOM_MOVE_LEFT, SWT.CTRL | SWT.ARROW_LEFT);

    k(VIEW_IMAGE_PREV_COLUMN, SWT.ARROW_LEFT);
    m(VIEW_IMAGE_PREV_COLUMN, SWT.BUTTON3, 1);
    k(VIEW_IMAGE_NEXT_COLUMN, SWT.ARROW_RIGHT);
    m(VIEW_IMAGE_NEXT_COLUMN, SWT.BUTTON1, 1);
    k(VIEW_IMAGE_PREV_ROW, SWT.ARROW_UP);
    k(VIEW_IMAGE_NEXT_ROW, SWT.ARROW_DOWN);
    k(VIEW_IMAGE_PREV_PAGE, SWT.PAGE_UP);
    k(VIEW_IMAGE_NEXT_PAGE, SWT.PAGE_DOWN);
    k(VIEW_IMAGE_TOP, SWT.HOME);
    k(VIEW_IMAGE_TOP, SWT.CTRL | SWT.HOME);
    k(VIEW_IMAGE_TAIL, SWT.END);
    k(VIEW_IMAGE_TAIL, SWT.CTRL | SWT.END);

    return map;
  }  
  
  private void k(Command cmd, int key) {
    map.addCommandInput(new KeyCombination(key), cmd);
  }
  private void m(Command cmd, int stateMask, int clickCount) {
    map.addCommandInput(new MouseCombination(stateMask, clickCount), cmd);
  }
}
