package cvj2.app.gui.data;

/**
 * FileListColumn のソート順
 */
public class FileListSortElement {
  private FileListColumn column;
  private boolean ascent;
  
  /**
   * コンストラクタ
   */
  FileListSortElement(FileListColumn column, boolean ascent) {
    this.column = column;
    this.ascent = ascent;
  }

  /**
   * ソート種別
   */
  public FileListColumn getColumn() {
    return column;
  }

  /**
   * 昇順か？
   */
  public boolean isAscent() {
    return ascent;
  }
  
  /**
   * ソート順を逆にしたオブジェクトを作る
   */
  FileListSortElement createReverse() {
    return new FileListSortElement(column, !ascent);
  }

  /**
   * 昇順にしたオブジェクトを作る
   */
  FileListSortElement createAscent() {
    return new FileListSortElement(column, true);
  }
}
