package cvj2.app.gui.dialogs;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.wb.swt.SWTResourceManager;

import cvj2.app.Config;
import cvj2.app.ParseArg;
import cvj2.app.gui.widgets.LinkWithURL;

/**
 * Aboutダイアログ
 */
public class AboutDialog extends Dialog {
  private Label label_appName;

  private boolean initialized = false;
  private Label labe_appVer;
  private Label lblNewLabel;
  private LinkWithURL link;
  private LinkWithURL link_1;
  private LinkWithURL link_2;
  private LinkWithURL link_3;
  private LinkWithURL link_4;
  private LinkWithURL link_5;
  private LinkWithURL link_6;
  private Label lblNewLabel_1;
  private Label lblNewLabel_2;
  private Text text_configDir;
  private LinkWithURL link_7;
  
  /**
   * コンストラクタ
   */
  public AboutDialog(Shell parentShell) {
    super(parentShell);
    setShellStyle(SWT.RESIZE | SWT.TITLE | SWT.PRIMARY_MODAL);
  }


  protected void initializeDialog(ControlEvent e) {
    if (initialized) return;
    initialized = true;

    getShell().setText("About");
    
    // アプリケーション名を大きくする
    FontData fd = getLabel_appName().getFont().getFontData()[0];
    Font appNameFont = SWTResourceManager.getFont(fd.getName(), fd.getHeight() * 2, fd.getStyle());
    getLabel_appName().setFont(appNameFont);
    
    // バージョン
    getLabe_appVer().setText("Ver." + Config.APP_VERSION);
    
    // 設定ディレクトリ
    getText_configDir().setText("" + ParseArg.configDir);
    
    getButton(IDialogConstants.OK_ID).setFocus();
    
    getShell().pack();
  }
  
  /**
   * Create contents of the dialog.
   * @param parent
   */
  @Override
  protected Control createDialogArea(Composite parent) {
    parent.addControlListener(new ControlAdapter() {
      @Override
      public void controlResized(ControlEvent e) {
        initializeDialog(e);
      }
    });
    Composite container = (Composite) super.createDialogArea(parent);
    
    label_appName = new Label(container, SWT.NONE);
    label_appName.setText("ComicViewerJ2");
    
    labe_appVer = new Label(container, SWT.NONE);
    labe_appVer.setText("Ver.??.??.??");
    new Label(container, SWT.NONE);
    
    lblNewLabel = new Label(container, SWT.NONE);
    lblNewLabel.setText("このソフトウェアは以下のライブラリ、ソフトウェア、データを使用して作られています　　　");
    
    link_4 = new LinkWithURL(container, SWT.NONE);
    link_4.setUrl("http://commons.apache.org/");
    link_4.setText("<a>Apache Commons CLI, Collections, Compress, IO, Lang</a>");
    
    link_7 = new LinkWithURL(container, SWT.NONE);
    link_7.setUrl("http://pdfbox.apache.org/");
    link_7.setText("<a>Apache PDFBox</a>");
    
    link_5 = new LinkWithURL(container, SWT.NONE);
    link_5.setUrl("http://www.f2ko.de/programs.php?lang=en&pid=b2e");
    link_5.setText("<a>Bat To Exe Converter</a>");
    
    link = new LinkWithURL(container, SWT.NONE);
    link.setUrl("http://www.eclipse.org");
    link.setText("<a>Eclipse SWT, JFace</a>");
    
    link_3 = new LinkWithURL(container, SWT.NONE);
    link_3.setUrl("http://v2c.s50.xrea.com/jmigemo/");
    link_3.setText("<a>J/Migemo</a>");
    
    link_1 = new LinkWithURL(container, SWT.NONE);
    link_1.setUrl("http://code.google.com/p/lucene-gosen/");
    link_1.setText("<a>lucene-gosen</a>");
    
    link_2 = new LinkWithURL(container, SWT.NONE);
    link_2.setUrl("http://0xcc.net/migemo/");
    link_2.setText("<a>Migemo</a>");
    
    link_6 = new LinkWithURL(container, SWT.NONE);
    link_6.setUrl("http://openiconlibrary.sourceforge.net/");
    link_6.setText("<a>Open Icon Library</a>");
    
    lblNewLabel_1 = new Label(container, SWT.NONE);
    lblNewLabel_1.setText(" ");
    
    lblNewLabel_2 = new Label(container, SWT.NONE);
    lblNewLabel_2.setText("現在の設定ディレクトリ");
    
    text_configDir = new Text(container, SWT.BORDER | SWT.READ_ONLY);
    text_configDir.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
    text_configDir.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));

    return container;
  }

  /**
   * Create contents of the button bar.
   * @param parent
   */
  @Override
  protected void createButtonsForButtonBar(Composite parent) {
    createButton(parent, IDialogConstants.OK_ID, IDialogConstants.OK_LABEL, true);
  }

  /**
   * Return the initial size of the dialog.
   */
  @Override
  protected Point getInitialSize() {
    return new Point(530, 490);
  }

  private Label getLabel_appName() {
    return label_appName;
  }
  private Label getLabe_appVer() {
    return labe_appVer;
  }
  private Text getText_configDir() {
    return text_configDir;
  }
}
