package cvj2.app.gui.dialogs;

import java.lang.reflect.InvocationTargetException;
import java.util.concurrent.atomic.AtomicInteger;

import org.eclipse.jface.dialogs.ProgressMonitorDialog;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Shell;

import cvj2.app.Config;

/**
 * 標準の ProgressMonitorDialog の幅が少し狭いので広げる
 */
public class MyProgressMonitorDialog extends ProgressMonitorDialog {
  private static AtomicInteger runningCount = new AtomicInteger();

  /**
   * 実行中かどうか
   */
  public static boolean isRunning() {
    return runningCount.get() > 0;
  }
  
  /**
   * コンストラクタ
   */
  public MyProgressMonitorDialog(Shell parent) {
    super(parent);
  }
  
  /**
   * オーバーライド
   */
  @Override
  protected Point getInitialSize() {
    Point p = super.getInitialSize();
    p.x += Config.get().getProgressMonitorDialogPlusWidth();
    return p;
  }

  /**
   * オーバーライド
   */
  @Override
  public void run(boolean fork, boolean cancelable, IRunnableWithProgress runnable) throws InvocationTargetException, InterruptedException {
    try {
      runningCount.incrementAndGet();
      super.run(fork, cancelable, runnable);
    }
    finally {
      runningCount.decrementAndGet();
    }
  }
}
