package cvj2.app.gui.widgets;

import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Link;

import cvj2.app.Main;
import cvj2.app.gui.util.MsgBox;

/**
 * URLリンクラベル
 */
public class LinkWithURL extends Link {
  private String url;
  
  /**
   * コンストラクタ
   */
  public LinkWithURL(Composite parent, int style) {
    super(parent, style);
    addSelectionListener(new SelectionAdapter() {
      @Override
      public void widgetSelected(SelectionEvent e) {
        launch(e);
      }
    });
  }

  /**
   * 起動
   */
  private void launch(SelectionEvent e) {
    if (url == null || url.length() <= 0) return;
    try {
      if (Program.launch(url)) return;
    }
    catch (Throwable ex) { }
    Main.getClipboard().setContents(
        new Object[] { url },
        new Transfer[] { TextTransfer.getInstance() });
    MsgBox.info("起動失敗", 
        "このOSではURLの起動ができないようです。\n" +
        "URLをクリップボードにコピーしておきましたので、\n" +
        "ブラウザーを開いて、アドレス欄に張り付けてください");
  }

  /**
   * URL取得
   */
  public String getUrl() {
    return url;
  }

  /**
   * URL設定
   */
  public void setUrl(String url) {
    this.url = url;
    setToolTipText(url);
  }

  /**
   * @see org.eclipse.swt.widgets.Widget#checkSubclass()
   */
  @Override
  protected void checkSubclass() { }
}
