package cvj2.app.gui.widgets;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;

import cvj2.app.Config;
import cvj2.app.command.Command;
import cvj2.app.gui.window.main.MainWindowCommandHandler;

/**
 * ポップアップメニュー
 */
public class ListPanelPopupMenu extends Menu {
  private MainWindowCommandHandler cmdHandler;

  /**
   * コンストラクタ
   */
  public ListPanelPopupMenu(Canvas parent, MainWindowCommandHandler cmdHandler) {
    super(parent);
    this.cmdHandler = cmdHandler;
    
    new MI(this, Config.OS_NAME + "の機能で開く(&O)", Command.FILE_EXEC);

    MenuItem lmi = new MenuItem(this, SWT.CASCADE);
    lmi.setText("プログラム起動(&L)");
    Menu lm = new Menu(lmi);
    lmi.setMenu(lm);
    Config.LaunchProgram[] launchProgs = Config.get().getLaunchPrograms();
    for (int i = 0; i < launchProgs.length; i++) {
      boolean hasId = i < Command.MAX_LAUNCH;
      Config.LaunchProgram p = launchProgs[i];
      if (hasId) {
        new MI(lm, p.getName() + (hasId ? "(&" + (i+1)%10 + ")" : ""), Command.values()[Command.FILE_LAUNCH_0.ordinal() + i]);
      }
      else {
        new MI(lm, p.getName(), Command.FILE_LAUNCH, "" + i);
      }
    }
    
    new MenuItem(this, SWT.SEPARATOR);
    new MI(this, "切り取り(&T)", Command.EDIT_CUT);
    new MI(this, "コピー(&C)", Command.EDIT_COPY);
    new MenuItem(this, SWT.SEPARATOR);
    new MI(this, "削除(&D)", Command.EDIT_DELETE);
    new MI(this, "名前変更(&R)", Command.EDIT_RENAME);
    new MenuItem(this, SWT.SEPARATOR);
    new MI(this, "プロパティ(&P)", Command.FILE_PROPERTY);
    parent.setMenu(this);
  }
  
  private class MI extends MenuItem {
    public MI(Menu menu, String name, final Command cmd) {
      this(menu, name, cmd, "");
    }
    public MI(Menu menu, String name, final Command cmd, final String actionId) {
      super(menu, SWT.NONE);
      super.setText(name);
      super.addSelectionListener(new SelectionAdapter() {
        @Override
        public void widgetSelected(SelectionEvent e) {
          cmdHandler.setLastInvokeActionId(actionId);
          cmdHandler.execCmd(cmd);
        }
      });
    }
    @Override
    protected void checkSubclass() { }
  }

  @Override
  protected void checkSubclass() { }
}
