package cvj2.app.gui.window;

import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.widgets.Shell;

import cvj2.app.gui.data.FileListSortElement;

/**
 * MainWindow, ViewWindow, ViewWindowFullscreen の共通のインターフェイス。<br>
 * <pre>
 * 各画面に以下の機能のインターフェイスを追加する
 * 1) Shell の取得
 * 2) ステータスバーのメッセージ
 * 3) ステータスバーのファイルメッセージ領域
 * 4) メニューの状態更新
 * 5) CTabFolder の取得
 * </pre>
 */
public interface CommonApplicationWindow {
  public Shell getShell();
  
  public void setStatus(String message, boolean isTemporary);
  
  public void setStatusFileMessage(String s);
  
  public void updateMenuState(boolean thumbnailMode, FileListSortElement sort);
  
  public CTabFolder getTabFolder();
}
