package cvj2.file.fs;

import java.io.File;

/**
 * PDFファイルのルート。
 * 
 * 詳しい性質などは、{@link FileInfoPDFRoot} を参照
 */
public class FileInfoPDFRoot extends FileInfoFs {
  // 子リスト
  FileInfoPDFList pdfList;

  /**
   * コンストラクタ
   * @param list null の場合がある
   */
  FileInfoPDFRoot(File f) {
    super(f);
  }

  @Override
  public boolean isDirectory() {
    return true;
  }

  @Override
  public boolean isArchiveRoot() {
    // 普通のディレクトリの場合
    if (super.isDirectory()) {
      return false;
    }
    return true;
  }

  @Override
  public FileInfoList getList() {
    // 普通のディレクトリだった場合
    if (!isArchiveRoot()) {
      assert pdfList == null;
      return super.getList();
    }
    
    if (pdfList != null) return pdfList;
    FileInfoPDFRoot other = FileInfoPDFManager.getFileInfoPDFRoot(file);
    if (other != null) pdfList = other.pdfList;
    if (pdfList == null) pdfList = new FileInfoPDFList(new FileInfoPDF[0]);
    return pdfList;
  }
}
