package cvj2.file.fs;

import java.io.File;

/**
 * ファイルシステムのルート。<br>
 * ※) unix の "/" ではない
 */
public class FileInfoRoot extends FileInfo {
  static final File ROOT_FILE = new File("<ROOT>");
  static private FileInfoRoot instance = new FileInfoRoot();
  
  /**
   * インスタンス取得
   */
  static FileInfoRoot getInstance() {
    return instance;
  }
  
  private FileInfoRoot() {
    super(ROOT_FILE);

    isAttributeInitialized = true;
    exists = true;
    isDirectory = true;
    length = 0;
    lastModified = 0;
  }
  
  @Override
  public String getName() {
    return "<ROOT>";
  }

  @Override
  public String toString() {
    return getName();
  }

  @Override
  public String getAbsolutePath() {
    return getName();
  }

  @Override
  public FileInfo getParent() {
    return this;
  }

  @Override
  public FileInfoList getList() {
    return new FileInfoFsList(getFile(), File.listRoots());
  }
  
  @Override
  protected void initAttribute() {
    /* コンストラクタで初期化済み */
  }

  @Override
  public boolean isImageFile() {
    return false;
  }

  @Override
  public FileInfo getArchiveRoot() {
    throw new RuntimeException(this.toString());
  }
}
