package cvj2.gui.swt.migemo;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyEvent;

import cvj2.gui.swt.ui.input.KeyCombination;
import cvj2.migemo.MigemoKeyHandler;

/**
 * SWTに対応した MigemoKeyHandler
 */
public class SWTMigemoKeyHandler extends MigemoKeyHandler {
  /**
   * 文字入力イベントの判定
   * @return 文字列として認識したら、true
   */
  public boolean handleKeyEvent(KeyEvent ev) {
    char c = ev.character;
    KeyCombination key = new KeyCombination(ev);
    
    // 入力が完了していないキーは無視する
    if (key.equals(new KeyCombination(SWT.CAPS_LOCK))) return false; 
    if (key.equals(new KeyCombination(SWT.NUM_LOCK))) return false; 
    if (key.equals(new KeyCombination(SWT.SHIFT))) return false; 
    if (key.equals(new KeyCombination(SWT.CONTROL))) return false; 
    if (key.equals(new KeyCombination(SWT.ALT))) return false; 
    if (key.equals(new KeyCombination(SWT.COMMAND))) return false; 

    boolean ok = true;
    // 文字入力をするキーのみ可
    if ((ev.keyCode & SWT.KEYCODE_BIT) != 0) ok = false;
    // テンキーは可
    if (ev.keyLocation == SWT.KEYPAD && ev.stateMask == 0) ok = true;
    // SHIFT以外は不可
    if (ev.stateMask != 0 && ev.stateMask != SWT.SHIFT) ok = false;
    // 文字かどうかチェック
    if (Character.isISOControl(c)) ok = false;
    
    if (!ok) {
      cancelKeySequence();
      return false;
    }
    handleKeyChar(c, ev.time);
    return true;
  }
}
