package cvj2.gui.swt.ui.input;

import java.util.Arrays;

/**
 * 入力の抽象クラス
 */
public abstract class InputCombination implements Comparable<InputCombination> {
  private Object[] data;

  /**
   * コンストラクタ
   * @deprecated XML読み書きのみで使用する
   */
  public InputCombination() {
    this("_INVALID_DATA_");
  }
  
  /**
   * コンストラクタ
   */
  protected InputCombination(Object... data) {
    this.data = data;
  }
  
  protected void setData(Object... data) {
    this.data = data;
  }
  protected Object[] getData() {
    return data;
  }
  
  /**
   * @see Object#toString()
   */
  @Override  
  public String toString() {
    return "" + data;
  }

  /**
   * @see Comparable#compareTo(Object)
   */
  @Override
  public int compareTo(InputCombination o) {
    String c0 = this.getClass().getName();
    String c1 = o.getClass().getName();
    if (!c0.equals(c1)) return c0.compareTo(c1);
    return Arrays.deepToString(data).compareTo(Arrays.deepToString(o.data));
  }

  @Override
  public boolean equals(Object obj) {
    if (obj == null) return false;
    InputCombination o = (InputCombination) obj;
    return Arrays.deepEquals(data, o.data);
  }

  @Override
  public int hashCode() {
    return ("" + data).hashCode();
  }
}
