package cvj2.gui.swt.ui.input;

import org.eclipse.swt.events.KeyEvent;

/**
 * キー入力データ
 */
public class KeyCombination extends InputCombination {
  /**
   * コンストラクタ
   * @deprecated XML読み書きのみで使用する
   */
  public KeyCombination() {
    super(Integer.MAX_VALUE);
  }
  
  /**
   * コンストラクタ
   */
  public KeyCombination(KeyEvent ev) {
    super((Integer)null);
    
    if (ev.keyCode == 0 && !Character.isISOControl(ev.character)) {
      // IME入力の場合
      setData(0xFFFF & ev.character);
    }
    else {
      setData(ev.keyCode | ev.stateMask);
    }
  }

  /**
   * コンストラクタ
   */
  public KeyCombination(int keyCodeAndStateMask) {
    super((Integer)null);
    setData(keyCodeAndStateMask);
  }

  /**
   * データ取得
   */
  public Integer getKeyData() {
    return (Integer) getData()[0];
  }
  
  /**
   * 使用禁止
   * @deprecated XML読み書きのみで使用する
   */
  public void setKeyData(Integer data) {
    setData(data);
  }

  /**
   * @see Object#toString()
   */
  @Override  
  public String toString() {
    return KeyCodeUtil.getKeyCodeAndStateMaskString(getKeyData());
  }
}
