package cvj2.gui.swt.ui.input;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;

/**
 * マウス入力データ
 */
public class MouseCombination extends InputCombination {
  
  /**
   * コンストラクタ
   */
  public MouseCombination(MouseEvent e) {
    super((Object)null);
    setData(combineButtonAndStateMask(e), e.count);
  }

  /**
   * コンストラクタ
   */
  public MouseCombination(int stateMask, int clickCount) {
    super((Object)null);
    setData(stateMask, clickCount);
  }
  
  /**
   * 使用禁止
   * @deprecated XML読み書きのみで使用する
   */
  public void setMouseData(Object[] data) {
    super.setData(data);
  }

  @Override  
  public String toString() {
    Object[] data = getData();
    return "(マウス) " + KeyCodeUtil.getStateMaskString((Integer)data[0]) + " x " + data[1];
  }
  
  static private int combineButtonAndStateMask(MouseEvent e) {
    int[] masks = {
        0,
        SWT.BUTTON1,
        SWT.BUTTON2,
        SWT.BUTTON3,
        SWT.BUTTON4,
        SWT.BUTTON5,
    };
    return e.stateMask | masks[e.button];
  }
}
