package cvj2.gui.swt.util;

import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;

import cvj2.app.Config;
import cvj2.util.Log;

/**
 * GCのラッパークラス
 */
public class GCX {
  private GC gc;

  public GCX(GC gc) {
    this.gc = gc;
  }
  
  public GC getGC() {
    return gc;
  }
  
  public void drawImage(Image image, int x, int y) {
    gc.drawImage(image, x, y);
  }
  public void drawImage(Image image, int srcX, int srcY, int srcWidth, int srcHeight, int destX, int destY, int destWidth, int destHeight) {
    if (!Config.get().isDebugMode()) {
      gc.drawImage(image, srcX, srcY, srcWidth, srcHeight, destX, destY, destWidth, destHeight);
    }
    else {
      try {
        gc.drawImage(image, srcX, srcY, srcWidth, srcHeight, destX, destY, destWidth, destHeight);
      }
      catch (RuntimeException ex) {
        Log.e("imgIsDisposed=", image.isDisposed(), ", srcX=", srcX, ", srcY=", srcY, ", srcW=", srcWidth, ", srcH=", srcHeight, ", destX=", destX, ", destY=", destY, ", destW=", destWidth, ", destH=", destHeight);
        throw ex;
      }
    }
  }
  public void drawLine(int x1, int y1, int x2, int y2) {
    gc.drawLine(x1, y1, x2, y2);
  }
  public void drawOval(int x, int y, int width, int height) {
    gc.drawOval(x, y, width - 1, height - 1); // ### 改変 ###
  }
  public void drawPoint(int x, int y) {
    gc.drawPoint(x, y);
  }
  
  public void drawRectangle(Rectangle rect) {
    drawRectangle(rect.x, rect.y, rect.width, rect.height);
  }
  public void drawRectangle(int x, int y, int width, int height) {
    gc.drawRectangle(x, y, width - 1, height - 1); // ### 改変 ###
  }
  public void fillRectangle(Rectangle rect) {
    fillRectangle(rect.x, rect.y, rect.width, rect.height);
  }
  public void fillRectangle(int x, int y, int width, int height) {
    gc.fillRectangle(x, y, width - 1, height - 1); // ### 改変 ###
  }
  public void drawString (String string, int x, int y) {
    gc.drawString(string, x, y);
  }  
  public void drawText(String string, int x, int y) {
    gc.drawText(string, x, y);
  }
  
  public void drawFocus(int x, int y, int width, int height) {
    gc.drawFocus(x, y, width, height);
  }

  public Rectangle getClipping() {
    return gc.getClipping();
  }
  public void setClipping(Rectangle rect) {
    gc.setClipping(rect);
  }
  public void setClipping(int x, int y, int width, int height) {
    gc.setClipping(x, y, width, height);
  }
  
  public Color getBackground() {
    return gc.getBackground();
  }
  public Color getForeground() {
    return gc.getForeground();
  }
  
  public void setBackground(Color color) {
    gc.setBackground(color);
  }
  public void setForeground(Color color) {
    gc.setForeground(color);
  }
  
  public Point stringExtent(String string) {
    return gc.stringExtent(string);
  }
}
