package cvj2.gui.swt.util;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.PaletteData;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.widgets.Display;

/**
 * 透明カーソル
 */
public class NullCursor {
  static private Cursor instance;
  
  /**
   * カーソル取得
   */
  static public Cursor get() {
    if (instance == null) {
      Color black = Display.getDefault().getSystemColor(SWT.COLOR_BLACK);
      ImageData imgCursor = new ImageData(1, 1, 8, new PaletteData(new RGB[] { black.getRGB() }));
      ImageData imgCursorMask = new ImageData(1, 1, 8, new PaletteData(new RGB[] { black.getRGB() }));
      imgCursorMask.setPixel(0, 0, 0);
      imgCursor.maskData = imgCursorMask.data;
      imgCursor.maskPad = imgCursorMask.scanlinePad;
      instance = new Cursor(Display.getCurrent(), imgCursor, 0, 0);
    }
    return instance;
  }
  
  /**
   * リソース破棄
   */
  static public void dispose() {
    if (instance != null) {
      instance.dispose();
      instance = null;
    }
  }
  
}
