package cvj2.gui.swt.widgets;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.List;

/**
 * Enum値のリスト画面部品
 */
public class EnumList <T extends java.lang.Enum<?>> extends List {
  private T[] enums;
  
  /**
   * コンストラクター
   */
  public EnumList(Composite parent, int style) {
    super(parent, style);
  }

  /**
   * 初期化
   */
  public void initByEnum(T[] enums) {
    this.enums = enums;
    super.removeAll();
    for (Enum<?> e : enums) {
      super.add(e.toString(), super.getItemCount());
    }
  }
  
  /**
   * 選択設定
   */
  public void setEnumSelection(T e) {
    for (int i = 0; i < enums.length; i++) {
      if (enums[i] != e) continue;
      super.setSelection(i);
      return;
    }
  }
  
  /**
   * 選択取得
   */
  public T getEnumSelection() {
    int sel = super.getSelectionIndex();
    if (sel < 0) return null;
    return enums[sel];
  }

  @Override
  protected void checkSubclass() { }
}
