package cvj2.gui.swt.widgets;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;

/**
 * 浮動小数点を入力するテキスト部品
 */
public class FloatText extends Text {
  private double minimum = 0.0;
  private double maximum = 1.0;
  
  /**
   * コンストラクタ
   */
  public FloatText(Composite parent, int style) {
    super(parent, style);
  }

  /**
   * 正しい値かどうかをチェックする
   */
  public String getInputErrorMessage(String valName) {
    try {
      double d = Double.parseDouble(super.getText());
      if (minimum <= d && d <= maximum) return null;
    }
    catch (Exception e) { }
    return "" + valName + "は " + minimum + " 以上 " + maximum + " 以下で入力してください";
  }
  
  /**
   * 値セット
   */
  public void setValue(double d) {
    super.setText(Double.toString(d));
  }
  
  /**
   * 値取得
   */
  public double getValue() {
    if (null != getInputErrorMessage("")) throw new NumberFormatException();
    return Double.parseDouble(super.getText());
  }
  
  public double getMinimum() {
    return minimum;
  }

  public void setMinimum(double minimum) {
    this.minimum = minimum;
  }

  public double getMaximum() {
    return maximum;
  }

  public void setMaximum(double maximum) {
    this.maximum = maximum;
  }

  @Override
  protected void checkSubclass() { }
}
