package cvj2.gui.swt.widgets;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.wb.swt.SWTResourceManager;

import cvj2.gui.swt.util.GCX;

/**
 * 画面部品の描画ユーティリティークラス
 */
public class WidgetPaintUtil {
  private static Color buttonColor_border = SWTResourceManager.getColor(SWT.COLOR_WIDGET_BORDER);
  private static Color buttonColor_bg = SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND);
  private static Color buttonColor_dark = SWTResourceManager.getColor(SWT.COLOR_WIDGET_NORMAL_SHADOW);
  private static Color buttonColor_light = SWTResourceManager.getColor(SWT.COLOR_WIDGET_HIGHLIGHT_SHADOW);

  /**
   * ボタンの画像を描画する
   */
  public static void drawButtonBg(GCX gcx, int x, int y, int width, int height, boolean push) {
    gcx.setBackground(buttonColor_bg);
    gcx.fillRectangle(x, y, width, height);
  }
  /**
   * ボタンの画像を描画する
   */
  public static void drawButtonFg(GCX gcx, int x, int y, int width, int height, boolean push) {
    // ボタンの外枠
    gcx.setForeground(buttonColor_border);
    gcx.drawRectangle(x, y, width, height);
    
    // ボタンの四隅
    gcx.setForeground(buttonColor_dark);
    gcx.drawPoint(x, y);
    gcx.drawPoint(x + width - 1, y);
    gcx.drawPoint(x, y + height - 1);
    gcx.drawPoint(x + width - 1, y + height - 1);
    
    // 外枠の1ドット内側の座標
    // | 0 1 |
    // | 2 3 |
    int x0  = x + 1;
    int y0  = y + 1;
    int x1  = x + (width - 1) - 1;
    int y2  = y + (height - 1) - 1;
    // 上、左
    gcx.setForeground(push ? buttonColor_dark : buttonColor_light);
    gcx.drawLine(x0, y0, x1 - 1, y0 );
    gcx.drawLine(x0, y0, x0,     y2 - 1);
    // 右、下
    gcx.setForeground(push ? buttonColor_light : buttonColor_dark);
    gcx.drawLine(x1,     y0 + 1, x1, y2);
    gcx.drawLine(x0 + 1, y2,     x1, y2);
  }
}
