package cvj2.gui.swt.widgets.gdidpanel;

import java.util.Set;

import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;

import cvj2.gui.swt.widgets.gdidpanel.GridPanel.CellPainter;
import cvj2.gui.swt.widgets.gdidpanel.GridPanel.Model;
import cvj2.util.Log;

/**
 * 描画
 */
public class GridPaintHandler {
  private Model model;
  private CellPainter painter;
  private GridSelection selection;
  private Point indent;

  /**
   * 描画情報の設定
   * @param indent 
   */
  public void setup(Model model, CellPainter painter, GridSelection selection, Point indent) {
    Log.start(model, painter, selection);
    this.model = model;
    this.painter = painter;
    this.selection = selection;
    this.indent = indent;
  }
  
  /**
   * 全セル描画
   */
  public void redrawAllCells(PaintEvent e) {
    if (selection == null || painter == null || model == null) return;

    Rectangle clip = e.gc.getClipping();
    int startIndex = selection.getScrollIndex() * selection.getColumn();
    int endIndex = (selection.getScrollIndex() + selection.getVisibleRow() + 1) * selection.getColumn();
    if (endIndex >= model.size()) endIndex = model.size();
    Log.ut("startIndex = ", startIndex, ", endIndex = ", endIndex, ", selection dump: ", selection.getDump());
    
    for (int index = startIndex; index < endIndex; index++) {
      Rectangle rect = selection.getCellRect(index);
      rect.width -= indent.x; 
      rect.height -= indent.y; 
      if (!clip.intersects(rect)) continue;
      boolean focus = selection.getFocusIndex() == index;
      Set<Integer> sel = selection.getSelectedIndices();
      e.gc.setClipping(rect);
      painter.paintControl(e.gc, rect, model.get(index), index, sel.contains(index), focus);
    }
  }
}
