package cvj2.img;

/**
 * 画像の回転角度。<br>
 * 値は反時計回りに 0 -> 1 -> 2 -> 3 -> 0
 */
public class ImageRotate implements Cloneable {
  private int rotate = 0; 
  
  /**
   * 回転させる
   * @param direction 1: 反時計回り、-1: 時計回り
   */
  public void rotate(int direction) {
    assert direction == -1 || direction == 1;
    rotate = (rotate + direction + 4) % 4;
  }

  /**
   * 回転角を取得
   */
  public int getRotate() {
    return rotate;
  }
  
  /**
   * 0度か180度
   */
  public boolean isHorizontal() {
    return rotate % 2 == 0;
  }
  
  @Override
  public String toString() {
    return "ImageRotate[" + rotate + "]";
  }
  
  @Override
  public ImageRotate clone() {
    try {
      return (ImageRotate ) super.clone();
    }
    catch (CloneNotSupportedException e) {
      throw new RuntimeException(e);
    }
  }

  @Override
  public boolean equals(Object obj) {
    if (obj == null) return false;
    return this.rotate == ((ImageRotate)obj).rotate;
  }

  @Override
  public int hashCode() {
    return rotate;
  }
}
