package cvj2.img.converter;

import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.awt.image.ConvolveOp;
import java.awt.image.ImagingOpException;
import java.awt.image.Kernel;

import cvj2.util.Log;

/**
 * 輪郭強調
 */
public class ImageSharpnessConverter implements ImageConverter {
  private float param;

  /**
   * コンストラクタ
   * @param param
   */
  public ImageSharpnessConverter(float param) {
    this.param = param;
  }

  /**
   * 変換
   */
  @Override
  public BufferedImage cnv(BufferedImage img) {
    if (param == 0.0) return img;
    float[] data = {
        0,      -param,        0,
        -param, 1 + 4 * param, -param,
        0,      -param,        0
    };
    Kernel k = new Kernel(3, 3, data);
    RenderingHints rh = new RenderingHints(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_SPEED);
    ConvolveOp cop = new ConvolveOp(k, ConvolveOp.EDGE_NO_OP, rh);
    try {
      return cop.filter(img, null);
    }
    catch (ImagingOpException e) {
      Log.e("変換失敗: ", e.getMessage());
      return img;
    }
  }
}
