package cvj2.img.converter;

import java.awt.Dimension;
import java.awt.geom.AffineTransform;
import java.awt.image.AffineTransformOp;
import java.awt.image.BufferedImage;

/**
 * java.awt.image.AffineTransformOp でサイズ変換する
 */
public class ImageSizeConverterAffineTransform extends ImageSizeConverter {
  private int affineTranaformType;

  /**
   * 拡大縮小率指定
   */
  public ImageSizeConverterAffineTransform(Double zoomRatio, int affineTranaformType) {
    super(zoomRatio);
    this.affineTranaformType = affineTranaformType;
  }

  /**
   * サイズ指定
   */
  public ImageSizeConverterAffineTransform(Dimension displaySize, int affineTranaformType) {
    super(displaySize);
    this.affineTranaformType = affineTranaformType;
  }

  @Override
  public BufferedImage cnv(BufferedImage img) {
    double ratio = super.getZoomRatio(img);
    Dimension size = super.getResultSize(img);

    AffineTransformOp aop = new AffineTransformOp(AffineTransform.getScaleInstance(ratio, ratio), affineTranaformType);
    int type = img.getType();
    BufferedImage newImg = new BufferedImage(size.width, size.height, type);
    newImg = aop.filter(img, newImg);
    return newImg;
  }
}
