package cvj2.img.converter;

import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

/**
 * java.swt.Image の getScaledInstance() でサイズ変換する
 */
public class ImageSizeConverterScaledInstance extends ImageSizeConverter {
  private int imageHint;

  /**
   * 拡大縮小率指定
   */
  public ImageSizeConverterScaledInstance(Double zoomRatio, int imageHint) {
    super(zoomRatio);
    this.imageHint = imageHint;
  }

  /**
   * サイズ指定
   */
  public ImageSizeConverterScaledInstance(Dimension displaySize, int imageHint) {
    super(displaySize);
    this.imageHint = imageHint;
  }

  @Override
  public BufferedImage cnv(BufferedImage img) {
    Dimension size = super.getResultSize(img);
    BufferedImage newImg = new BufferedImage(size.width, size.height, img.getType());
    Graphics2D g2 = newImg.createGraphics();
    g2.drawImage(img.getScaledInstance(size.width, size.height, imageHint), 0, 0, null);
    g2.dispose();
    return newImg;
  }
}
