package cvj2.img.converter;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

/**
 * 画像種別変換
 */
public class ImageTypeConverter implements ImageConverter {
  public static Color backgroundColor = null;
  private int type;
  
  public ImageTypeConverter(int bufferedImageType) {
    this.type = bufferedImageType;
  }

  @Override
  public BufferedImage cnv(BufferedImage img) {
    if (img.getType() == type) return img;
    BufferedImage newImg = new BufferedImage(img.getWidth(), img.getHeight(), type);
    Graphics2D g2 = (Graphics2D) newImg.getGraphics();
    if (backgroundColor != null) {
      g2.setColor(backgroundColor);
      g2.fillRect(0, 0, newImg.getWidth(), newImg.getHeight());
    }
    g2.drawImage(img, null, 0, 0);
    g2.dispose();
    return newImg;
  }
}
