package cvj2.img.loader;

import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.InputStream;

import javax.imageio.ImageIO;

/**
 * javax.imageio.ImageIO を使用した画像ロードプラグイン
 */
public class ImageLoaderPluginImageIO extends ImageLoaderPlugin {
  {
    addExt("bmp");
    addExt("jpg");
    addExt("jpeg");
    addExt("gif");
    addExt("png");
    addExt("wbmp");
  }
  
  public ImageLoaderPluginImageIO() {
    super("ImageIO");
  }

  @Override
  public BufferedImage load(InputStream in) throws IOException {
    try {
      BufferedImage img = ImageIO.read(in);
      if (img == null) throw new IOException("read fail");
      return img;
    }
    catch (IllegalArgumentException e) {
      throw new IOException(e.getMessage());
    }
  }
}
