package cvj2.migemo;

/**
 * 汎用検索インターフェイス
 */
public interface Searcher {
  /**
   * ユーザーの入力したローマ字文字列をセットする
   * 
   * @param inputRomaji 検索文字列 (grep における、引数の役目)
   */
  public void setInputRomaji(String inputRomaji);

  /**
   * 検索対象文字列から一致する箇所を探す
   * あらかじめ、setInputStr() を呼んでおく
   * 
   * @param fileText 検索対象文字列 (grep における、ファイルの1行の役目)
   * @return 一致したら、{ 一致した箇所の開始位置、終了位置+1 }
   *          一致しなければ、null。
   */
  public int[] foundIn(String fileText);
}
