package cvj2.util;

import java.util.HashMap;
import java.util.Map;

/**
 * ひらがなをカタナカに変換する。<br>
 * (Migemoがひらがなとカタカナの境界を意識してしまうため)
 */
public class CnvHira2Kata {
  static private Map<Character, Character> map = new HashMap<Character, Character>();

  static private char cnvTbl[][] = new char[][] {
    { 'ア', 'あ' },
    { 'イ', 'い' },
    { 'ウ', 'う' },
    { 'エ', 'え' },
    { 'オ', 'お' },
    { 'カ', 'か' },
    { 'キ', 'き' },
    { 'ク', 'く' },
    { 'ケ', 'け' },
    { 'コ', 'こ' },
    { 'サ', 'さ' },
    { 'シ', 'し' },
    { 'ス', 'す' },
    { 'セ', 'せ' },
    { 'ソ', 'そ' },
    { 'タ', 'た' },
    { 'チ', 'ち' },
    { 'ツ', 'つ' },
    { 'テ', 'て' },
    { 'ト', 'と' },
    { 'ナ', 'な' },
    { 'ニ', 'に' },
    { 'ヌ', 'ぬ' },
    { 'ネ', 'ね' },
    { 'ノ', 'の' },
    { 'ハ', 'は' },
    { 'ヒ', 'ひ' },
    { 'フ', 'ふ' },
    { 'ヘ', 'へ' },
    { 'ホ', 'ほ' },
    { 'マ', 'ま' },
    { 'ミ', 'み' },
    { 'ム', 'む' },
    { 'メ', 'め' },
    { 'モ', 'も' },
    { 'ヤ', 'や' },
    { 'ユ', 'ゆ' },
    { 'ヨ', 'よ' },
    { 'ラ', 'ら' },
    { 'リ', 'り' },
    { 'ル', 'る' },
    { 'レ', 'れ' },
    { 'ロ', 'ろ' },
    { 'ワ', 'わ' },
    { 'ヲ', 'を' },
    { 'ン', 'ん' },

    { 'ガ', 'が' },
    { 'ギ', 'ぎ' },
    { 'グ', 'ぐ' },
    { 'ゲ', 'げ' },
    { 'ゴ', 'ご' },
    { 'ザ', 'ざ' },
    { 'ジ', 'じ' },
    { 'ズ', 'ず' },
    { 'ゼ', 'ぜ' },
    { 'ゾ', 'ぞ' },
    { 'ダ', 'だ' },
    { 'ヂ', 'ぢ' },
    { 'ヅ', 'づ' },
    { 'デ', 'で' },
    { 'ド', 'ど' },
    { 'バ', 'ば' },
    { 'パ', 'ぱ' },
    { 'ビ', 'び' },
    { 'ピ', 'ぴ' },
    { 'ブ', 'ぶ' },
    { 'プ', 'ぷ' },
    { 'ベ', 'べ' },
    { 'ペ', 'ぺ' },
    { 'ボ', 'ぼ' },
    { 'ポ', 'ぽ' },
    { 'ヴ', 'ヴ' },
    { 'ヰ', 'ゐ' },
    { 'ヱ', 'ゑ' },

    { 'ァ', 'ぁ' },
    { 'ィ', 'ぃ' },
    { 'ゥ', 'ぅ' },
    { 'ェ', 'ぇ' },
    { 'ォ', 'ぉ' },
    { 'ャ', 'ゃ' },
    { 'ュ', 'ゅ' },
    { 'ョ', 'ょ' },
    { 'ヮ', 'ゎ' },
    { 'ッ', 'っ' },

  };
  static {
    for (char[] tbl: cnvTbl) {
      map.put(tbl[1], tbl[0]);
    }
  }
  
  /**
   * 変換
   */
  static public char cnv(char c) {
    Character cnv = map.get(c);
    if (cnv == null) return c;
    return cnv;
  }
  
  /**
   * 変換
   */
  static public String cnv(String str) {
    StringBuilder sb = new StringBuilder();
    for (int i = 0; i < str.length(); i++) {
      sb.append(cnv(str.charAt(i)));
    }
    return sb.toString();
  }
}
