package cvj2.util;

/**
 * 自動的に区切り文字を付加する文字列構築クラス
 */
public class DelimString {
  private String delim1;
  private String delim2;
  private StringBuilder list = new StringBuilder();

  /**
   * コンストラクタ
   * @param delims [0]: append() の呼び出しごとに末尾につける区切り (例: ", ")
   *         delims [1]: append() を複数引数で呼び出したときに引数間につける区切り (例: " = ")
   */
  public DelimString(String... delims) {
    assert delims.length <= 2;
    if (delims.length > 0) this.delim1 = delims[0];
    if (delims.length > 1) this.delim2 = delims[1];
  }

  /**
   * 文字列追加
   */
  public DelimString append(Object... objects) {
    if (list.length() != 0 && delim1 != null) list.append(delim1);
    for (int i = 0; i < objects.length; i++) {
      if (i > 0 && delim2 != null) list.append(delim2);
      list.append(objects[i]);
    }
    return this;
  }
  
  @Override
  public String toString() {
    return list.toString();
  }
}
