package cvj2.util;

/**
 * 遅延束縛文字列 (デバッグログ出力に使用する)
 */
abstract public class LateBindString {
  @Override
  public String toString() {
    return create();
  }

  /**
   * このメソッドをオーバーライドして、その中で文字列を生成する
   * (実際にログ出力が行われない限り、このメソッドは呼ばれない)
   */
  public abstract String create();
}
